import java.io.*;
public class MemGeneratorNcore{
    public static void main(String[]args){
        try{
            FileOutputStream fostest=new FileOutputStream("test.txt");
            PrintStream pstest=new PrintStream(fostest);
//            conj(pstest,"GLO25","OR","or",25);
//            conj(pstest,"GLO19","OR","or",19);
//            conj(pstest,"GLO13","OR","or",13);
//            createadditionalcodeforxpro32main(pstest);
//            createfloatmemempty(pstest,args);
//            createfloatmem(pstest,args);
            memcreate(pstest,args);
            memconcreate(pstest,args);
//            testmaincreate2(pstest,args);
            pstest.close();
            fostest.close();
        }
        catch(Exception e){
        }
    }
    public static void testmaincreate(PrintStream ps,String[]args){
        try{
            int ncore=0;
            if(args.length==3){
                ncore=new Integer(args[2]).intValue();
            }
            if(args.length==4){
                ncore=new Integer(args[3]).intValue();
            }
            ps.println("MODULE main{");
            ps.println("CYCLE 0;");
            ps.println("CONSTANT c 0;");
            ps.println("CONSTANT d 1;");
            ps.println("coremem0 coremem;");
            ps.println("coremem1 corememb;");
            for(int k=0;k<ncore;k++){
                if(k==0){
                    ps.println("CONNECT d coremem.readcore"+(k+1)+";");
                }
                else{
                    ps.println("CONNECT c coremem.readcore"+(k+1)+";");
                }
                ps.println("CONNECT coremem.readocore"+(k+1)+" corememb.readcore"+(k+1)+";");
                ps.println("CONNECT c coremem.writecore"+(k+1)+";");
                ps.println("CONNECT coremem.writeocore"+(k+1)+" corememb.writecore"+(k+1)+";");
                ps.println("CONNECT c coremem.testandsetcore"+(k+1)+";");
                ps.println("CONNECT coremem.testandsetocore"+(k+1)+" corememb.testandsetcore"+(k+1)+";");
                for(int j=1;j<=32;j++){
                    if(k==0){
                        ps.println("CONNECT d coremem.readin"+j+"core"+(k+1)+";");
                    }
                    else{
                        ps.println("CONNECT c coremem.readin"+j+"core"+(k+1)+";");
                    }
                    ps.println("CONNECT coremem.readino"+j+"core"+(k+1)+" corememb.readin"+j+"core"+(k+1)+";");
                }
                ps.println("CONNECT d coremem.readat1core"+(k+1)+";");
                for(int j=2;j<=32;j++){
                    ps.println("CONNECT c coremem.readat"+j+"core"+(k+1)+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT coremem.readato"+j+"core"+(k+1)+" corememb.readat"+j+"core"+(k+1)+";");
                }
            }
            ps.println("}");
        }
        catch(Exception e){
        }
    }
    public static void testmaincreate2(PrintStream ps,String[]args){
        try{
            int ncore=0;
            if(args.length==3){
                ncore=new Integer(args[2]).intValue();
            }
            if(args.length==4){
                ncore=new Integer(args[3]).intValue();
            }
            ps.println("MODULE main{");
            ps.println("CYCLE 0;");
            ps.println("CONSTANT c 0;");
            ps.println("CONSTANT d 1;");
            ps.println("MEMCON coremem;");
            for(int k=0;k<ncore;k++){
                if(k==0){
                    ps.println("CONNECT d coremem.readcore"+(k+1)+";");
                }
                else{
                    ps.println("CONNECT c coremem.readcore"+(k+1)+";");
                }
                ps.println("CONNECT c coremem.writecore"+(k+1)+";");
                ps.println("CONNECT c coremem.testandsetcore"+(k+1)+";");
                for(int j=1;j<=32;j++){
                    if(k==0){
                        ps.println("CONNECT d coremem.readin"+j+"core"+(k+1)+";");
                    }
                    else{
                        ps.println("CONNECT c coremem.readin"+j+"core"+(k+1)+";");
                    }
                }
                ps.println("CONNECT d coremem.readat1core"+(k+1)+";");
                for(int j=2;j<=32;j++){
                    ps.println("CONNECT c coremem.readat"+j+"core"+(k+1)+";");
                }
            }
            ps.println("}");
        }
        catch(Exception e){
        }
    }
    public static void memconcreate(PrintStream ps,String[]args){
        try{
            int ncore=0;
            if(args.length==3){
                ncore=new Integer(args[2]).intValue();
            }
            if(args.length==4){
                ncore=new Integer(args[3]).intValue();
            }
            int begin=new Integer(args[0]).intValue();
            int end=new Integer(args[1]).intValue();
            for(int k=1;k<ncore;k++){
                conj(ps,"COLLISIONOR"+(k+1),"OR","or",k);
            }
            ps.println("MODULE MEMCON{");
            ps.println("CYCLE 0;");
            for(int k=0;k<ncore;k++){
                ps.println("IN readcore"+(k+1)+";");
                ps.println("IN writecore"+(k+1)+";");
                ps.println("IN testandsetcore"+(k+1)+";");
                for(int j=1;j<=32;j++){
                    ps.println("IN readin"+j+"core"+(k+1)+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("IN readat"+j+"core"+(k+1)+";");
                }
                ps.println("OUT readocore"+(k+1)+";");
                ps.println("OUT writeocore"+(k+1)+";");
                ps.println("OUT testandsetocore"+(k+1)+";");
                for(int j=1;j<=32;j++){
                    ps.println("OUT readino"+j+"core"+(k+1)+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("OUT readato"+j+"core"+(k+1)+";");
                }
            }
            for(int i=begin;i<=end;i++){
                ps.println("coremem"+i+" xprocoremem"+i+";");
            }
            ps.println("CONSTANT c 0;");
            for(int k=1;k<ncore;k++){
                for(int l=0;l<k;l++){
                    for(int m=1;m<=32;m++){
                        ps.println("XOR xor"+m+"core"+(k+1)+"x"+(l+1)+"in1 xor"+m+"core"+(k+1)+"x"+(l+1)+"in2 xor"+m+"core"+(k+1)+"x"+(l+1)+"out;");
                    }
                    ps.println("MEMGLOBOR xoror"+(k+1)+"x"+(l+1)+";");
                    ps.println("INV xororinv"+(k+1)+"x"+(l+1)+"in xororinv"+(k+1)+"x"+(l+1)+"out;");
                }
            }
            for(int k=0;k<ncore;k++){
                ps.println("OR writeortest"+(k+1)+"in1 writeortest"+(k+1)+"in2 writeortest"+(k+1)+"out;");
            }
            for(int k=1;k<ncore;k++){
                for(int l=0;l<k;l++){
                    ps.println("AND bothwriteortest"+(k+1)+"x"+(l+1)+"in1 bothwriteortest"+(k+1)+"x"+(l+1)+"in2 bothwriteortest"+(k+1)+"x"+(l+1)+"out;");
                    ps.println("AND bothwriteortestandxornull"+(k+1)+"x"+(l+1)+"in1 bothwriteortestandxornull"+(k+1)+"x"+(l+1)+"in2 bothwriteortestandxornull"+(k+1)+"x"+(l+1)+"out;");
                }
            }
            for(int k=1;k<ncore;k++){
                ps.println("COLLISIONOR"+(k+1)+" collisionor"+(k+1)+";");
            }
            for(int k=1;k<ncore;k++){
                ps.println("INV collisionorinv"+(k+1)+"in collisionorinv"+(k+1)+"out;");
                ps.println("AND writenullerand"+(k+1)+"in1 writenullerand"+(k+1)+"in2 writenullerand"+(k+1)+"out;");
                ps.println("AND testnullerand"+(k+1)+"in1 testnullerand"+(k+1)+"in2 testnullerand"+(k+1)+"out;");
                ps.println("AND testlostwithcollision"+(k+1)+"in1 testlostwithcollision"+(k+1)+"in2 testlostwithcollision"+(k+1)+"out;");
                ps.println("AND writelostwithcollision"+(k+1)+"in1 writelostwithcollision"+(k+1)+"in2 writelostwithcollision"+(k+1)+"out;");
            }
            for(int k=1;k<ncore;k++){
                for(int j=1;j<=32;j++){
                    ps.println("AND readinnocollision"+j+"core"+(k+1)+"in1 readinnocollision"+j+"core"+(k+1)+"in2 readinnocollision"+j+"core"+(k+1)+"out;");
                    ps.println("AND readintestcollision"+j+"core"+(k+1)+"in1 readintestcollision"+j+"core"+(k+1)+"in2 readintestcollision"+j+"core"+(k+1)+"out;");
                    ps.println("AND readinwritecollision"+j+"core"+(k+1)+"in1 readinwritecollision"+j+"core"+(k+1)+"in2 readinwritecollision"+j+"core"+(k+1)+"out;");
                    ps.println("OR withcollision"+j+"core"+(k+1)+"in1 withcollision"+j+"core"+(k+1)+"in2 withcollision"+j+"core"+(k+1)+"out;");
                    ps.println("OR readinocalc"+j+"core"+(k+1)+"in1 readinocalc"+j+"core"+(k+1)+"in2 readinocalc"+j+"core"+(k+1)+"out;");
                }
            }
            for(int k=1;k<ncore;k++){
                for(int l=0;l<k;l++){
                    for(int m=1;m<=32;m++){
                        ps.println("CONNECT readat"+m+"core"+(k+1)+" xor"+m+"core"+(k+1)+"x"+(l+1)+"in1;");
                        ps.println("CONNECT readat"+m+"core"+(l+1)+" xor"+m+"core"+(k+1)+"x"+(l+1)+"in2;");
                        ps.println("CONNECT xor"+m+"core"+(k+1)+"x"+(l+1)+"out xoror"+(k+1)+"x"+(l+1)+".in"+m+";");
                        ps.println("CONNECT xoror"+(k+1)+"x"+(l+1)+".out xororinv"+(k+1)+"x"+(l+1)+"in;");
                    }
                }
            }
            for(int k=0;k<ncore;k++){
                ps.println("CONNECT writecore"+(k+1)+" writeortest"+(k+1)+"in1;");
                ps.println("CONNECT testandsetcore"+(k+1)+" writeortest"+(k+1)+"in2;");
            }
            for(int k=1;k<ncore;k++){
                for(int l=0;l<k;l++){
                    ps.println("CONNECT writeortest"+(k+1)+"out bothwriteortest"+(k+1)+"x"+(l+1)+"in1;");
                    ps.println("CONNECT writeortest"+(l+1)+"out bothwriteortest"+(k+1)+"x"+(l+1)+"in2;");
                    ps.println("CONNECT bothwriteortest"+(k+1)+"x"+(l+1)+"out bothwriteortestandxornull"+(k+1)+"x"+(l+1)+"in1;");
                    ps.println("CONNECT xororinv"+(k+1)+"x"+(l+1)+"out bothwriteortestandxornull"+(k+1)+"x"+(l+1)+"in2;");
                }
            }
            for(int k=1;k<ncore;k++){
                for(int l=0;l<k;l++){
                    ps.println("CONNECT bothwriteortestandxornull"+(k+1)+"x"+(l+1)+"out collisionor"+(k+1)+".in"+(l+1)+";");
                }
            }
            for(int k=1;k<ncore;k++){
                ps.println("CONNECT collisionor"+(k+1)+".out collisionorinv"+(k+1)+"in;");
                ps.println("CONNECT collisionorinv"+(k+1)+"out writenullerand"+(k+1)+"in1;");
                ps.println("CONNECT writecore"+(k+1)+" writenullerand"+(k+1)+"in2;");
                ps.println("CONNECT collisionorinv"+(k+1)+"out testnullerand"+(k+1)+"in1;");
                ps.println("CONNECT testandsetcore"+(k+1)+" testnullerand"+(k+1)+"in2;");
                ps.println("CONNECT collisionor"+(k+1)+".out testlostwithcollision"+(k+1)+"in1;");
                ps.println("CONNECT testandsetcore"+(k+1)+" testlostwithcollision"+(k+1)+"in2;");
                ps.println("CONNECT collisionor"+(k+1)+".out writelostwithcollision"+(k+1)+"in1;");
                ps.println("CONNECT writecore"+(k+1)+" writelostwithcollision"+(k+1)+"in2;");
            }
            for(int k=1;k<ncore;k++){
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT collisionorinv"+(k+1)+"out readinnocollision"+j+"core"+(k+1)+"in1;");
                    ps.println("CONNECT xprocoremem"+end+".readino"+j+"core"+(k+1)+" readinnocollision"+j+"core"+(k+1)+"in2;");
                    ps.println("CONNECT testlostwithcollision"+(k+1)+"out readintestcollision"+j+"core"+(k+1)+"in1;");
                    ps.println("CONNECT c readintestcollision"+j+"core"+(k+1)+"in2;");
                    ps.println("CONNECT writelostwithcollision"+(k+1)+"out readinwritecollision"+j+"core"+(k+1)+"in1;");
                    ps.println("CONNECT xprocoremem"+end+".readino"+j+"core"+(k+1)+" readinwritecollision"+j+"core"+(k+1)+"in2;");
                }
            }
            for(int k=1;k<ncore;k++){
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT readintestcollision"+j+"core"+(k+1)+"out withcollision"+j+"core"+(k+1)+"in1;");
                    ps.println("CONNECT readinwritecollision"+j+"core"+(k+1)+"out withcollision"+j+"core"+(k+1)+"in2;");
                    ps.println("CONNECT withcollision"+j+"core"+(k+1)+"out readinocalc"+j+"core"+(k+1)+"in1;");
                    ps.println("CONNECT readinnocollision"+j+"core"+(k+1)+"out readinocalc"+j+"core"+(k+1)+"in2;");
                }
            }
            for(int k=0;k<ncore;k++){
                ps.println("CONNECT readcore"+(k+1)+" xprocoremem"+begin+".readcore"+(k+1)+";");
                if(k>0){
                    ps.println("CONNECT writenullerand"+(k+1)+"out xprocoremem"+begin+".writecore"+(k+1)+";");
                    ps.println("CONNECT testnullerand"+(k+1)+"out xprocoremem"+begin+".testandsetcore"+(k+1)+";");
                }
                else{
                    ps.println("CONNECT writecore"+(k+1)+" xprocoremem"+begin+".writecore"+(k+1)+";");
                    ps.println("CONNECT testandsetcore"+(k+1)+" xprocoremem"+begin+".testandsetcore"+(k+1)+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT readin"+j+"core"+(k+1)+" xprocoremem"+begin+".readin"+j+"core"+(k+1)+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT readat"+j+"core"+(k+1)+" xprocoremem"+begin+".readat"+j+"core"+(k+1)+";");
                }
                ps.println("CONNECT xprocoremem"+end+".readocore"+(k+1)+" readocore"+(k+1)+";");
                ps.println("CONNECT writecore"+(k+1)+" writeocore"+(k+1)+";");
                ps.println("CONNECT testandsetcore"+(k+1)+" testandsetocore"+(k+1)+";");
                if(k>0){
                    for(int j=1;j<=32;j++){
                        ps.println("CONNECT readinocalc"+j+"core"+(k+1)+"out readino"+j+"core"+(k+1)+";");
                    }
                }
                else{
                    for(int j=1;j<=32;j++){
                        ps.println("CONNECT xprocoremem"+end+".readino"+j+"core"+(k+1)+" readino"+j+"core"+(k+1)+";");
                    }
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT xprocoremem"+end+".readato"+j+"core"+(k+1)+" readato"+j+"core"+(k+1)+";");
                }
            }
            for(int i=begin;i<end;i++){
                for(int k=0;k<ncore;k++){
                    ps.println("CONNECT xprocoremem"+i+".readocore"+(k+1)+" xprocoremem"+(i+1)+".readcore"+(k+1)+";");
                    ps.println("CONNECT xprocoremem"+i+".writeocore"+(k+1)+" xprocoremem"+(i+1)+".writecore"+(k+1)+";");
                    ps.println("CONNECT xprocoremem"+i+".testandsetocore"+(k+1)+" xprocoremem"+(i+1)+".testandsetcore"+(k+1)+";");
                    for(int j=1;j<=32;j++){
                        ps.println("CONNECT xprocoremem"+i+".readino"+j+"core"+(k+1)+" xprocoremem"+(i+1)+".readin"+j+"core"+(k+1)+";");
                    }
                    for(int j=1;j<=32;j++){
                        ps.println("CONNECT xprocoremem"+i+".readato"+j+"core"+(k+1)+" xprocoremem"+(i+1)+".readat"+j+"core"+(k+1)+";");
                    }
                }
            }
            ps.println("}");
        }
        catch(Exception e){
        }
    }
    public static void memcreate(PrintStream ps,String[]args){
        try{
            int begin=new Integer(args[0]).intValue();
            int end=new Integer(args[1]).intValue();
            int ncore=0;
            int[]filedata=new int[(end-begin+1)*4];
            if(args.length==4){
                String initfile=args[2];
                FileInputStream fis=new FileInputStream(initfile);
                int inp=-1;
                int c=0;
                while((inp=fis.read())!=-1){
                    filedata[c]=inp;
                    c++;
                }
                fis.close();
                ncore=new Integer(args[3]).intValue();
            }
            if(args.length==3){
                ncore=new Integer(args[2]).intValue();
            }
            conj(ps,"MEMGLOBAND","AND","and",32);
            conj(ps,"MEMGLOBOR","OR","or",32);
            conj(ps,"GLOBORN","OR","or",ncore);
            ps.println("MODULE TESTANDSETSAVER{");
            ps.println("CYCLE 1;");
            for(int j=0;j<32;j++){
                ps.println("IN in"+(j+1)+";");
            }
            for(int j=0;j<32;j++){
                ps.println("OUT out"+(j+1)+";");
            }
            for(int j=0;j<32;j++){
                ps.println("CONNECT in"+(j+1)+" out"+(j+1)+";");
            }
            ps.println("}");
            int fpos=0;
            for(int i=begin;i<=end;i++){
                int n=i;
                int[]bj=new int[32];
                for(int j=0;j<32;j++){
                    bj[j]=n%2;
                    n=n/2;
                }
                ps.println("MODULE coremem"+i+"{");
                for(int k=0;k<ncore;k++){
                    ps.println("IN readcore"+(k+1)+";");
                    ps.println("IN writecore"+(k+1)+";");
                    ps.println("IN testandsetcore"+(k+1)+";");
                    for(int j=1;j<=32;j++){
                        ps.println("IN readin"+j+"core"+(k+1)+";");
                    }
                    for(int j=1;j<=32;j++){
                        ps.println("IN readat"+j+"core"+(k+1)+";");
                    }
                    ps.println("OUT readocore"+(k+1)+";");
                    ps.println("OUT writeocore"+(k+1)+";");
                    ps.println("OUT testandsetocore"+(k+1)+";");
                    for(int j=1;j<=32;j++){
                        ps.println("OUT readino"+j+"core"+(k+1)+";");
                    }
                    for(int j=1;j<=32;j++){
                        ps.println("OUT readato"+j+"core"+(k+1)+";");
                    }
                }
                ps.println("CONSTANT c 0;");
                ps.println("CONSTANT d 1;");
                ps.println("TESTANDSETSAVER testandsetsaver;");
                for(int k=0;k<ncore;k++){
                    ps.println("INV inv"+(k+1)+"in inv"+(k+1)+"out;");
                }
                for(int k=0;k<ncore;k++){
                    for(int j=0;j<32;j++){
                        if(bj[j]==0){
                            ps.println("INV inv"+(j+1)+"core"+(k+1)+"in inv"+(j+1)+"core"+(k+1)+"out;");
                        }
                    }
                }
                for(int k=0;k<ncore;k++){
                    ps.println("MEMGLOBAND globcore"+(k+1)+";");
                    ps.println("AND readandcore"+(k+1)+"in1 readandcore"+(k+1)+"in2 readandcore"+(k+1)+"out;");
                    ps.println("AND writeandcore"+(k+1)+"in1 writeandcore"+(k+1)+"in2 writeandcore"+(k+1)+"out;");
                    ps.println("AND testandsetandcore"+(k+1)+"in1 testandsetandcore"+(k+1)+"in2 testandsetandcore"+(k+1)+"out;");
                }
//                ps.println("GLOBORN globorreadcore;");
                ps.println("GLOBORN globorwritecore;");
//                ps.println("GLOBORN globortestandsetcore;");
//                ps.println("OR writeortestandsetorin1 writeortestandsetorin2 writeortestandsetorout;");
//                ps.println("OR firstwriteortestandsetorin1 firstwriteortestandsetorin2 firstwriteortestandsetorout;");
//                ps.println("INV firstactiveinvin firstactiveinvout;");
//                ps.println("OR secondwriteortestandsetorin1 secondwriteortestandsetorin2 secondwriteortestandsetorout;");
//                ps.println("AND secondisallowedandin1 secondisallowedandin2 secondisallowedandout;");
//                ps.println("OR isactiveorcore2in1 isactiveorcore2in2 isactiveorcore2out;");
                for(int k=2;k<ncore;k++){
//                    ps.println("OR writeortestandsetcore"+(k+1)+"in1 writeortestandsetcore"+(k+1)+"in2 writeortestandsetcore"+(k+1)+"out;");
//                    ps.println("INV corekisallowedinv"+(k+1)+"in corekisallowedinv"+(k+1)+"out;");
//                    ps.println("AND corekisallowedandwants"+(k+1)+"in1 corekisallowedandwants"+(k+1)+"in2 corekisallowedandwants"+(k+1)+"out;");
//                    ps.println("OR isactiveorcore"+(k+1)+"in1 isactiveorcore"+(k+1)+"in2 isactiveorcore"+(k+1)+"out;");
                }
                ps.println("GLOBORN globorreadvalues[32];");
                ps.println("MEMGLOBOR globortest;");
                ps.println("INV testandsetinvin testandsetinvout;");
                for(int k=0;k<ncore;k++){
//                    ps.println("AND bitisnullandset"+(k+1)+"in1 bitisnullandset"+(k+1)+"in2 bitisnullandset"+(k+1)+"out;");
                    ps.println("AND readselectbandcore"+(k+1)+"in1 readselectbandcore"+(k+1)+"in2 readselectbandcore"+(k+1)+"out;");
                }
                ps.println("GLOBORN globorreadvaluesb;");
                for(int j=1;j<=32;j++){
                    ps.println("OR readselector"+j+"in1 readselector"+j+"in2 readselector"+j+"out;");
                }
                for(int k=0;k<ncore;k++){
//                    ps.println("AND writewonandcore"+(k+1)+"in1 writewonandcore"+(k+1)+"in2 writewonandcore"+(k+1)+"out;");
//                    ps.println("AND testandsetwonandcore"+(k+1)+"in1 testandsetwonandcore"+(k+1)+"in2 testandsetwonandcore"+(k+1)+"out;");
                    ps.println("OR writeortestandsetor"+(k+1)+"in1 writeortestandsetor"+(k+1)+"in2 writeortestandsetor"+(k+1)+"out;");//new
                    ps.println("OR readortestandsetcore"+(k+1)+"in1 readortestandsetcore"+(k+1)+"in2 readortestandsetcore"+(k+1)+"out;");
                }
                for(int k=0;k<ncore;k++){
//                    ps.println("OR failedbitnotnullornotwoncore"+(k+1)+"in1 failedbitnotnullornotwoncore"+(k+1)+"in2 failedbitnotnullornotwoncore"+(k+1)+"out;");
//                    ps.println("INV testandsetwonandinvcore"+(k+1)+"in testandsetwonandinvcore"+(k+1)+"out;");
                    ps.println("AND testandsetandfailedcore"+(k+1)+"in1 testandsetandfailedcore"+(k+1)+"in2 testandsetandfailedcore"+(k+1)+"out;");
                    ps.println("INV failedinvcore"+(k+1)+"in failedinvcore"+(k+1)+"out;");
                }
                for(int k=0;k<ncore;k++){
                    for(int j=1;j<=32;j++){
                        ps.println("AND readselectand"+j+"core"+(k+1)+"in1 readselectand"+j+"core"+(k+1)+"in2 readselectand"+j+"core"+(k+1)+"out;");
                        ps.println("AND aand"+j+"core"+(k+1)+"in1 aand"+j+"core"+(k+1)+"in2 aand"+j+"core"+(k+1)+"out;");
                        ps.println("AND band"+j+"core"+(k+1)+"in1 band"+j+"core"+(k+1)+"in2 band"+j+"core"+(k+1)+"out;");
                        ps.println("AND cand"+j+"core"+(k+1)+"in1 cand"+j+"core"+(k+1)+"in2 cand"+j+"core"+(k+1)+"out;");
                        ps.println("OR or"+j+"core"+(k+1)+"in1 or"+j+"core"+(k+1)+"in2 or"+j+"core"+(k+1)+"out;");
                    }
                }
                int val1=filedata[fpos];
                for(int j=25;j<=32;j++){
                    ps.println("BIT bitin"+j+" bitout"+j+" bitread"+j+" bitset"+j+" "+(val1%2)+";");
                    val1=val1/2;
                }
                fpos++;
                val1=filedata[fpos];
                for(int j=17;j<=24;j++){
                    ps.println("BIT bitin"+j+" bitout"+j+" bitread"+j+" bitset"+j+" "+(val1%2)+";");
                    val1=val1/2;
                }
                fpos++;
                val1=filedata[fpos];
                for(int j=9;j<=16;j++){
                    ps.println("BIT bitin"+j+" bitout"+j+" bitread"+j+" bitset"+j+" "+(val1%2)+";");
                    val1=val1/2;
                }
                fpos++;
                val1=filedata[fpos];
                for(int j=1;j<=8;j++){
                    ps.println("BIT bitin"+j+" bitout"+j+" bitread"+j+" bitset"+j+" "+(val1%2)+";");
                    val1=val1/2;
                }
                fpos++;
                for(int k=0;k<ncore;k++){
                    for(int j=1;j<=32;j++){
                        ps.println("AND aand"+j+"core"+(k+1)+"in1 aand"+j+"core"+(k+1)+"in2 aand"+j+"core"+(k+1)+"out;");
                    }
                }
                for(int k=0;k<ncore;k++){
                    for(int j=1;j<=32;j++){
                        ps.println("AND band"+j+"core"+(k+1)+"in1 band"+j+"core"+(k+1)+"in2 band"+j+"core"+(k+1)+"out;");
                    }
                }
                for(int k=0;k<ncore;k++){
                    for(int j=1;j<=32;j++){
                        ps.println("OR or"+j+"core"+(k+1)+"in1 or"+j+"core"+(k+1)+"in2 or"+j+"core"+(k+1)+"out;");
                    }
                }
                for(int k=0;k<ncore;k++){
                    for(int j=0;j<32;j++){
                        if(bj[j]==0){
                            ps.println("CONNECT readat"+(j+1)+"core"+(k+1)+" inv"+(j+1)+"core"+(k+1)+"in;");
                            ps.println("CONNECT inv"+(j+1)+"core"+(k+1)+"out globcore"+(k+1)+".in"+(j+1)+";");
                        }
                        else{
                            ps.println("CONNECT readat"+(j+1)+"core"+(k+1)+" globcore"+(k+1)+".in"+(j+1)+";");
                        }
                    }
                }
                for(int k=0;k<ncore;k++){
                    ps.println("CONNECT readcore"+(k+1)+" readandcore"+(k+1)+"in1;");
                    ps.println("CONNECT globcore"+(k+1)+".out readandcore"+(k+1)+"in2;");
                    ps.println("CONNECT writecore"+(k+1)+" writeandcore"+(k+1)+"in1;");
                    ps.println("CONNECT globcore"+(k+1)+".out writeandcore"+(k+1)+"in2;");
                    ps.println("CONNECT testandsetcore"+(k+1)+" testandsetandcore"+(k+1)+"in1;");
                    ps.println("CONNECT globcore"+(k+1)+".out testandsetandcore"+(k+1)+"in2;");
                    ps.println("CONNECT writeandcore"+(k+1)+"out writeortestandsetor"+(k+1)+"in1;");//new
                    ps.println("CONNECT testandsetandcore"+(k+1)+"out writeortestandsetor"+(k+1)+"in2;");//new
                }
                for(int k=0;k<ncore;k++){
//                    ps.println("CONNECT readandcore"+(k+1)+"out globorreadcore.in"+(k+1)+";");
                    ps.println("CONNECT writeortestandsetor"+(k+1)+"out globorwritecore.in"+(k+1)+";");//new
//                    ps.println("CONNECT writeandcore"+(k+1)+"out globorwritecore.in"+(k+1)+";");
//                    ps.println("CONNECT testandsetwonandcore"+(k+1)+"out bitisnullandset"+(k+1)+"in1;");
//                    ps.println("CONNECT testandsetinvout bitisnullandset"+(k+1)+"in2;");
//                    ps.println("CONNECT bitisnullandset"+(k+1)+"out globortestandsetcore.in"+(k+1)+";");
                }
//                ps.println("CONNECT globorwritecore.out writeortestandsetorin1;");
//                ps.println("CONNECT globortestandsetcore.out writeortestandsetorin2;");
//                ps.println("CONNECT writeandcore1out firstwriteortestandsetorin1;");
//                ps.println("CONNECT testandsetandcore1out firstwriteortestandsetorin2;");
//                ps.println("CONNECT firstwriteortestandsetorout firstactiveinvin;");
//                ps.println("CONNECT writeandcore2out secondwriteortestandsetorin1;");
//                ps.println("CONNECT testandsetandcore2out secondwriteortestandsetorin2;");
//                ps.println("CONNECT firstactiveinvout secondisallowedandin1;");
//                ps.println("CONNECT secondwriteortestandsetorout secondisallowedandin2;");
//                ps.println("CONNECT firstwriteortestandsetorout isactiveorcore2in1;");
//                ps.println("CONNECT secondisallowedandout isactiveorcore2in2;");
                for(int k=2;k<ncore;k++){
//                    ps.println("CONNECT writeandcore"+(k+1)+"out writeortestandsetcore"+(k+1)+"in1;");
//                    ps.println("CONNECT testandsetandcore"+(k+1)+"out writeortestandsetcore"+(k+1)+"in2;");
//                    ps.println("CONNECT isactiveorcore"+k+"out corekisallowedinv"+(k+1)+"in;");
//                    ps.println("CONNECT writeortestandsetcore"+(k+1)+"out corekisallowedandwants"+(k+1)+"in1;");
//                    ps.println("CONNECT corekisallowedinv"+(k+1)+"out corekisallowedandwants"+(k+1)+"in2;");
//                    ps.println("CONNECT isactiveorcore"+k+"out isactiveorcore"+(k+1)+"in1;");
//                    ps.println("CONNECT corekisallowedandwants"+(k+1)+"out isactiveorcore"+(k+1)+"in2;");
                }
//                ps.println("CONNECT firstwriteortestandsetorout writewonandcore1in1;");
//                ps.println("CONNECT writeandcore1out writewonandcore1in2;");
//                ps.println("CONNECT secondisallowedandout writewonandcore2in1;");
//                ps.println("CONNECT writeandcore2out writewonandcore2in2;");
                for(int k=2;k<ncore;k++){
//                    ps.println("CONNECT corekisallowedandwants"+(k+1)+"out writewonandcore"+(k+1)+"in1;");
//                    ps.println("CONNECT writeandcore"+(k+1)+"out writewonandcore"+(k+1)+"in2;");
                }
                for(int k=0;k<ncore;k++){
                    for(int j=0;j<32;j++){
                        ps.println("CONNECT readin"+(j+1)+"core"+(k+1)+" readselectand"+(j+1)+"core"+(k+1)+"in1;");
//                        ps.println("CONNECT writewonandcore"+(k+1)+"out readselectand"+(j+1)+"core"+(k+1)+"in2;");
                        ps.println("CONNECT writeandcore"+(k+1)+"out readselectand"+(j+1)+"core"+(k+1)+"in2;");//new
                        ps.println("CONNECT readselectand"+(j+1)+"core"+(k+1)+"out globorreadvalues["+j+"].in"+(k+1)+";");
                    }
                }
                for(int j=0;j<32;j++){
                    ps.println("CONNECT globorreadvalues["+j+"].out readselector"+(j+1)+"in1;");
                }
//                ps.println("CONNECT firstwriteortestandsetorout testandsetwonandcore1in1;");
//                ps.println("CONNECT testandsetandcore1out testandsetwonandcore1in2;");
//                ps.println("CONNECT secondisallowedandout testandsetwonandcore2in1;");
//                ps.println("CONNECT testandsetandcore2out testandsetwonandcore2in2;");
                for(int k=2;k<ncore;k++){
//                    ps.println("CONNECT corekisallowedandwants"+(k+1)+"out testandsetwonandcore"+(k+1)+"in1;");
//                    ps.println("CONNECT testandsetandcore"+(k+1)+"out testandsetwonandcore"+(k+1)+"in2;");
                }
                for(int j=0;j<32;j++){
                    ps.println("CONNECT testandsetsaver.out"+(j+1)+" globortest.in"+(j+1)+";");
                }
                ps.println("CONNECT globortest.out testandsetinvin;");
                for(int k=0;k<ncore;k++){
                    ps.println("CONNECT testandsetinvout readselectbandcore"+(k+1)+"in1;");
                    ps.println("CONNECT testandsetandcore"+(k+1)+"out readselectbandcore"+(k+1)+"in2;");//new
//                    ps.println("CONNECT testandsetwonandcore"+(k+1)+"out readselectbandcore"+(k+1)+"in2;");
                    ps.println("CONNECT readselectbandcore"+(k+1)+"out globorreadvaluesb.in"+(k+1)+";");
                }
                ps.println("CONNECT globorreadvaluesb.out readselector1in2;");
                for(int j=1;j<32;j++){
                    ps.println("CONNECT c readselector"+(j+1)+"in2;");
                }
                for(int k=0;k<ncore;k++){
                    ps.println("CONNECT readandcore"+(k+1)+"out readortestandsetcore"+(k+1)+"in1;");
                    ps.println("CONNECT testandsetandcore"+(k+1)+"out readortestandsetcore"+(k+1)+"in2;");//new
//                    ps.println("CONNECT testandsetwonandcore"+(k+1)+"out readortestandsetcore"+(k+1)+"in2;");
                }
                for(int k=0;k<ncore;k++){
//                    ps.println("CONNECT globortest.out failedbitnotnullornotwoncore"+(k+1)+"in1;");
//                    ps.println("CONNECT testandsetwonandcore"+(k+1)+"out testandsetwonandinvcore"+(k+1)+"in;");
//                    ps.println("CONNECT testandsetwonandinvcore"+(k+1)+"out failedbitnotnullornotwoncore"+(k+1)+"in2;");
//                    ps.println("CONNECT testandsetcore"+(k+1)+" testandsetandfailedcore"+(k+1)+"in1;");
//                    ps.println("CONNECT failedbitnotnullornotwoncore"+(k+1)+"out testandsetandfailedcore"+(k+1)+"in2;");
                    ps.println("CONNECT testandsetandcore"+(k+1)+"out testandsetandfailedcore"+(k+1)+"in1;");//new
                    ps.println("CONNECT globortest.out testandsetandfailedcore"+(k+1)+"in2;");//new
                    ps.println("CONNECT testandsetandfailedcore"+(k+1)+"out failedinvcore"+(k+1)+"in;");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT d bitread"+j+";");
                    ps.println("CONNECT globorwritecore.out bitset"+j+";");
                    ps.println("CONNECT readselector"+j+"out bitin"+j+";");
                    ps.println("CONNECT bitout"+j+" testandsetsaver.in"+j+";");
                }
                for(int k=0;k<ncore;k++){
                    for(int j=1;j<=32;j++){
                        ps.println("CONNECT bitout"+j+" cand"+j+"core"+(k+1)+"in1;");
                        ps.println("CONNECT failedinvcore"+(k+1)+"out cand"+j+"core"+(k+1)+"in2;");
                        ps.println("CONNECT cand"+j+"core"+(k+1)+"out aand"+j+"core"+(k+1)+"in1;");
                        ps.println("CONNECT readortestandsetcore"+(k+1)+"out aand"+j+"core"+(k+1)+"in2;");
                    }
                }
                for(int k=0;k<ncore;k++){
                    ps.println("CONNECT readortestandsetcore"+(k+1)+"out inv"+(k+1)+"in;");
                }
                for(int k=0;k<ncore;k++){
                    for(int j=1;j<=32;j++){
                        ps.println("CONNECT inv"+(k+1)+"out band"+j+"core"+(k+1)+"in1;");
                        ps.println("CONNECT readin"+j+"core"+(k+1)+" band"+j+"core"+(k+1)+"in2;");
                    }
                }
                for(int k=0;k<ncore;k++){
                    for(int j=1;j<=32;j++){
                        ps.println("CONNECT aand"+j+"core"+(k+1)+"out or"+j+"core"+(k+1)+"in1;");
                        ps.println("CONNECT band"+j+"core"+(k+1)+"out or"+j+"core"+(k+1)+"in2;");
                        ps.println("CONNECT or"+j+"core"+(k+1)+"out readino"+j+"core"+(k+1)+";");
                        ps.println("CONNECT readat"+j+"core"+(k+1)+" readato"+j+"core"+(k+1)+";");
                    }
                    ps.println("CONNECT readcore"+(k+1)+" readocore"+(k+1)+";");
                    ps.println("CONNECT writecore"+(k+1)+" writeocore"+(k+1)+";");
                    ps.println("CONNECT testandsetcore"+(k+1)+" testandsetocore"+(k+1)+";");
                }
                ps.println("}");
            }
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
    public static void conj(PrintStream ps,String modulename,String conjtype,String conjname,int conjnum){
        try{
            ps.println("MODULE "+modulename+"{");
            ps.println("CYCLE 0;");
            for(int i=0;i<conjnum;i++){
                ps.println("IN in"+(i+1)+";");
            }
            ps.println("OUT out;");
            int inputs=conjnum;
            int andscalced=inputs/2;
            int andsinline=inputs/2;
            int firstlinerest=inputs%2;
            if(firstlinerest==1){
                andscalced=andscalced+1;
                if(inputs==1){
                    andscalced=0;
                }
            }
            while(andsinline>1){
                int linerest=andsinline%2;
                andsinline=andsinline/2;
                andscalced=andscalced+andsinline;
                if(linerest==1){
                    andscalced=andscalced+1;
                }
            }
            for(int i=0;i<andscalced;i++){
                ps.println(conjtype+" "+conjname+(i+1)+"in1 "+conjname+(i+1)+"in2 "+conjname+(i+1)+"out;");
            }
            int inputnumber=-1;
            int number=-1;
            int number2=-1;
            int ands1=-1;
            int ands=-1;
            int linebegin=0;
            int nextlinebegin=inputs;
            int restinputs=inputs%2;
            if(restinputs==1){
                inputnumber=inputs;
            }
            if(inputs>1){
                ands1=inputs/2;
                for(int i=0;i<ands1;i++){
                    ps.println("CONNECT in"+(i*2+1)+" "+conjname+(i+1)+"in1;");
                    ps.println("CONNECT in"+(i*2+2)+" "+conjname+(i+1)+"in2;");
                }
                int restands1=ands1%2;
                if(restands1==1){
                    number=linebegin+ands1;
                }
                nextlinebegin=ands1;
                ands=ands1;
                while(ands>1){
                    ands=ands/2;
                    int restands=ands%2;
                    for(int i=0;i<ands;i++){
                        ps.println("CONNECT "+conjname+(linebegin+i*2+1)+"out "+conjname+(nextlinebegin+i+1)+"in1;");
                        ps.println("CONNECT "+conjname+(linebegin+i*2+2)+"out "+conjname+(nextlinebegin+i+1)+"in2;");
                    }
                    linebegin=nextlinebegin;
                    nextlinebegin=nextlinebegin+ands;
                    if(inputnumber>0&&number>0){
                        if(restands==1){
                            number2=nextlinebegin;
                        }
                        nextlinebegin=nextlinebegin+1;
                        ps.println("CONNECT in"+inputnumber+" "+conjname+nextlinebegin+"in1;");
                        ps.println("CONNECT "+conjname+number+"out "+conjname+nextlinebegin+"in2;");
                        number=nextlinebegin;
                        inputnumber=-1;
                    }
                    else if(inputnumber<=0&&number>0&&number2>0){
                        nextlinebegin=nextlinebegin+1;
                        ps.println("CONNECT "+conjname+number+"out "+conjname+nextlinebegin+"in1;");
                        ps.println("CONNECT "+conjname+number2+"out "+conjname+nextlinebegin+"in2;");
                        number=nextlinebegin;
                        number2=-1;
                        inputnumber=-1;
                        if(restands==1){
                            number2=nextlinebegin-1;
                        }
                    }
                    else if(number<=0&&number2<=0){
                        if(restands==1){
                            number=nextlinebegin;
                        }
                    }
                    else if(inputnumber<=0&&number>0&&number2<=0){
                        if(restands==1){
                            number2=nextlinebegin;
                        }
                    }
                }
                int lastnumbers=nextlinebegin;
                if(number==lastnumbers){
                    number=-1;
                    if(number2>0){
                        number=number2;
                        number2=-1;
                    }
                }
                else if(number2==lastnumbers){
                    number2=-1;
                }
                if(inputnumber>0&&number>0){
                    ps.println("CONNECT in"+inputnumber+" "+conjname+(lastnumbers+1)+"in1;");
                    ps.println("CONNECT "+conjname+number+"out "+conjname+(lastnumbers+1)+"in2;");
                    ps.println("CONNECT "+conjname+lastnumbers+"out "+conjname+(lastnumbers+2)+"in1;");
                    ps.println("CONNECT "+conjname+(lastnumbers+1)+"out "+conjname+(lastnumbers+2)+"in2;");
                    lastnumbers=lastnumbers+2;
                }
                else if(number>0&&number2>0){
                    ps.println("CONNECT "+conjname+number+"out "+conjname+(lastnumbers+1)+"in1;");
                    ps.println("CONNECT "+conjname+number2+"out "+conjname+(lastnumbers+1)+"in2;");
                    ps.println("CONNECT "+conjname+lastnumbers+"out "+conjname+(lastnumbers+2)+"in1;");
                    ps.println("CONNECT "+conjname+(lastnumbers+1)+"out "+conjname+(lastnumbers+2)+"in2;");
                    lastnumbers=lastnumbers+2;
                }
                else if(inputnumber>0){
                    ps.println("CONNECT in"+inputnumber+" "+conjname+(lastnumbers+1)+"in1;");
                    ps.println("CONNECT "+conjname+lastnumbers+"out "+conjname+(lastnumbers+1)+"in2;");
                    lastnumbers=lastnumbers+1;
                }
                else if(number>0){
                    ps.println("CONNECT "+conjname+number+"out "+conjname+(lastnumbers+1)+"in1;");
                    ps.println("CONNECT "+conjname+lastnumbers+"out "+conjname+(lastnumbers+1)+"in2;");
                    lastnumbers=lastnumbers+1;
                }
                ps.println("CONNECT "+conjname+lastnumbers+"out out;");
            }
            else{
                ps.println("CONNECT in1 out;");
            }
            ps.println("}");
        }
        catch(Exception e){
        }
    }
    public static void createfloatmem(PrintStream ps,String[]args){
        try{
            int ncore=0;
            if(args.length==3){
                ncore=new Integer(args[2]).intValue();
            }
            if(args.length==4){
                ncore=new Integer(args[3]).intValue();
            }
            ps.println("MODULE FLOATMEM{");
            ps.println("CYCLE 0;");
            ps.println("IN read;");
            ps.println("IN write;");
            for(int j=1;j<=32;j++){
                ps.println("IN readin"+j+";");
            }
            for(int j=1;j<=32;j++){
                ps.println("IN readat"+j+";");
            }
            ps.println("OUT reado;");
            ps.println("OUT writeo;");
            for(int j=1;j<=32;j++){
                ps.println("OUT readino"+j+";");
            }
            for(int j=1;j<=32;j++){
                ps.println("OUT readato"+j+";");
            }
            ps.println("mem4294967291 flopmem0;");
            ps.println("mem4294967292 flopmem1;");
            ps.println("mem4294967293 flopmem2;");
            ps.println("mem4294967294 flopmem3;");
            ps.println("mem4294967295 flopmem4;");
            ps.println("CONNECT read flopmem0.read;");
            ps.println("CONNECT write flopmem0.write;");
            for(int j=1;j<=32;j++){
                ps.println("CONNECT readin"+j+" flopmem0.readin"+j+";");
            }
            for(int j=1;j<=32;j++){
                ps.println("CONNECT readat"+j+" flopmem0.readat"+j+";");
            }
            for(int i=0;i<4;i++){
                ps.println("CONNECT flopmem"+i+".reado flopmem"+(i+1)+".read;");
                ps.println("CONNECT flopmem"+i+".writeo flopmem"+(i+1)+".write;");
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT flopmem"+i+".readino"+j+" flopmem"+(i+1)+".readin"+j+";");
                }
                for(int j=1;j<=32;j++){
                    ps.println("CONNECT flopmem"+i+".readato"+j+" flopmem"+(i+1)+".readat"+j+";");
                }
            }
            ps.println("CONNECT flopmem4.reado reado;");
            ps.println("CONNECT flopmem4.writeo writeo;");
            for(int j=1;j<=32;j++){
                ps.println("CONNECT flopmem4.readino"+j+" readino"+j+";");
            }
            for(int j=1;j<=32;j++){
                ps.println("CONNECT flopmem4.readato"+j+" readato"+j+";");
            }
            ps.println("}");
        }
        catch(Exception e){
        }
    }
    public static void createfloatmemempty(PrintStream ps,String[]args){
        try{
            int ncore=0;
            if(args.length==3){
                ncore=new Integer(args[2]).intValue();
            }
            if(args.length==4){
                ncore=new Integer(args[3]).intValue();
            }
            ps.println("MODULE FLOATMEM{");
            ps.println("CYCLE 0;");
            ps.println("IN read;");
            ps.println("IN write;");
            for(int j=1;j<=32;j++){
                ps.println("IN readin"+j+";");
            }
            for(int j=1;j<=32;j++){
                ps.println("IN readat"+j+";");
            }
            ps.println("OUT reado;");
            ps.println("OUT writeo;");
            for(int j=1;j<=32;j++){
                ps.println("OUT readino"+j+";");
            }
            for(int j=1;j<=32;j++){
                ps.println("OUT readato"+j+";");
            }
            ps.println("CONNECT read reado;");
            ps.println("CONNECT write writeo;");
            for(int j=1;j<=32;j++){
                ps.println("CONNECT readin"+j+" readino"+j+";");
            }
            for(int j=1;j<=32;j++){
                ps.println("CONNECT readat"+j+" readato"+j+";");
            }
            ps.println("}");
        }
        catch(Exception e){
        }
    }
    public static void createadditionalcodeforxpro32main(PrintStream ps){
        try{
            for(int j=1;j<=32;j++){
                ps.println("AND numberofcoresand"+j+"in1 numberofcoresand"+j+"in2 numberofcoresand"+j+"out;");
            }
            for(int j=1;j<=32;j++){
                ps.println("AND corenumberand"+j+"in1 corenumberand"+j+"in2 corenumberand"+j+"out;");
            }
            for(int j=1;j<=32;j++){
                ps.println("AND testandsetand"+j+"in1 testandsetand"+j+"in2 testandsetand"+j+"out;");
            }
            for(int j=1;j<=32;j++){
                ps.println("CONNECT opcode.out46 numberofcoresand"+j+"in1;");
            }
            for(int j=1;j<=32;j++){
                if(j==1){
                    ps.println("CONNECT d numberofcoresand"+j+"in2;");
                }
                else{
                    ps.println("CONNECT c numberofcoresand"+j+"in2;");
                }
            }
            for(int j=1;j<=32;j++){
                ps.println("CONNECT opcode.out47 corenumberand"+j+"in1;");
            }
            for(int j=1;j<=32;j++){
                ps.println("CONNECT c corenumberand"+j+"in2;");
            }
            for(int j=1;j<=32;j++){
                ps.println("CONNECT testandsetmem.out testandsetand"+j+"in1;");
            }
            for(int j=1;j<=32;j++){
                ps.println("CONNECT memcon.readino"+j+" testandsetand"+j+"in2;");
            }
            for(int j=1;j<=8;j++){
                ps.println("CONNECT numberofcoresand"+j+"out glo25["+(j-1)+"].in23;");
                ps.println("CONNECT corenumberand"+j+"out glo25["+(j-1)+"].in24;");
                ps.println("CONNECT testandsetand"+j+"out glo25["+(j-1)+"].in25;");
            }
            for(int j=1;j<=8;j++){
                ps.println("CONNECT numberofcoresand"+(j+8)+"out glo19["+(j-1)+"].in17;");
                ps.println("CONNECT corenumberand"+(j+8)+"out glo19["+(j-1)+"].in18;");
                ps.println("CONNECT testandsetand"+(j+8)+"out glo19["+(j-1)+"].in19;");
            }
            for(int j=1;j<=16;j++){
                ps.println("CONNECT numberofcoresand"+(j+16)+"out glo13["+(j-1)+"].in11;");
                ps.println("CONNECT corenumberand"+(j+16)+"out glo13["+(j-1)+"].in12;");
                ps.println("CONNECT testandsetand"+(j+16)+"out glo13["+(j-1)+"].in13;");
            }
        }
        catch(Exception e){
        }
    }
}
